## d1x-rebirth 0.60~git20250524

=== SConstruct ===
#SConstruct
# vim: set fenc=utf-8 sw=4 ts=4 :
# 7a84b3f307ac6f72fd440e55b149d7c2c942dfaf

# needed imports
from collections import (defaultdict, Counter as collections_counter)
import collections.abc
from dataclasses import dataclass
import base64
import binascii
import errno
import itertools
import shlex
import subprocess
import sys
import typing
import os
import SCons.Util
import SCons.Script
from functools import cached_property

# Disable injecting tools into default namespace
SCons.Defaults.DefaultEnvironment(tools = [])

def message(program, msg: str):
	print(f'{program.program_message_prefix}: {msg}')

def get_Werror_sequence(active_cxxflags: list[str], warning_flags: collections.abc.Sequence[str]) -> list[str]:
	# The leading -W is passed in each element in warning_flags so that if
	# -Werror is already set, the warning_flags can be returned as-is.  This
	# also means that the warning flag is written in the caller as it will be
	# on the command line, so users who grep for `-Wfoo` will find where
	# `-Wfoo` is set.  If the `-W` were composed in this function and the
	# caller passed `foo`, then a search for `-Wfoo` would find nothing.
	if active_cxxflags and '-Werror' in active_cxxflags:
		# Make both paths return a Python list.
		return list(warning_flags)
	# When an option is converted to `-Werror=foo` form, the leading `-W` from
	# the caller must be stripped off to avoid producing `-Werror=-Wfoo`.
	return [f'-Werror={warning[2:]}' for warning in warning_flags]

class StaticSubprocess:
	# This class contains utility functions for calling subprocesses
	# that are expected to return the same output for every call.  The
	# output is cached after the first call, so that callers can request
	# the output again later without causing the program to be run again.
	#
	# Suitable programs are not required to depend solely on the
	# parameters, but are assumed to depend only on state that is
	# unlikely to change in the brief time that SConstruct runs.  For
	# example, a tool might be upgraded by the system administrator,
	# changing its version string.  However, we assume nobody upgrades
	# their tools in the middle of an SConstruct run.  Results are not
	# cached to persistent storage, so an upgrade performed after one
	# SConstruct run, but before the next, will not cause any
	# inconsistencies.
	shlex_split = shlex.split

	@dataclass(eq=False)
	class CachedCall:
		out: bytes
		err: bytes
		returncode: int

	@dataclass(eq=False)
	class CachedVersionCall:
		version_head: str
		def __init__(self, out: bytes, err: bytes, returncode: int):
			oe = out or err
			self.version_head = oe.splitlines()[0].decode() if not returncode and oe else None

	# @staticmethod delayed so that default arguments pick up the
	# undecorated form.
	def pcall(args: list[bytes | str], stderr=None, CachedCall=CachedCall, _call_cache: dict[str, CachedCall]={}) -> CachedCall:
		# Use repr since callers may construct the same argument
		# list independently.
		## >>> a = ['git', '--version']
		## >>> b = ['git', '--version']
		## >>> a is b
		## False
		## >>> id(a) == id(b)
		## False
		## >>> a == b
		## True
		## >>> repr(a) == repr(b)
		## True
		a = repr(args)
		c = _call_cache.get(a)
		if c is not None:
			return c
		p = subprocess.Popen(args, stdout=subprocess.PIPE, stderr=stderr)
		(o, e) = p.communicate()
		_call_cache[a] = c = CachedCall(o, e, p.wait())
		return c
	def qcall(args: str, stderr=None, _pcall=pcall, _shlex_split=shlex_split) -> CachedCall:
		return _pcall(_shlex_split(args),stderr)
	@classmethod
	def get_version_head(cls, cmd: bytes | str, _pcall=pcall, _shlex_split=shlex_split) -> str:
		# If cmd is bytes, then it is output from a program and should
		# not be reparsed.
		return _pcall(([cmd] if isinstance(cmd, bytes) else _shlex_split(cmd)) + ['--version'], stderr=subprocess.PIPE, CachedCall=cls.CachedVersionCall).version_head
	pcall = staticmethod(pcall)
	qcall = staticmethod(qcall)
	shlex_split = staticmethod(shlex_split)

class ToolchainInformation(StaticSubprocess):
	@staticmethod
	def get_tool_path(env: SCons.Environment, tool: str, _qcall=StaticSubprocess.qcall):
		# Include $LINKFLAGS since -fuse-ld=gold influences the path
		# printed for the linker.
		tool = env.subst(f'$CXX $CXXFLAGS $LINKFLAGS -print-prog-name={tool}')
		return tool, _qcall(tool).out.strip()
	@staticmethod
	def show_partial_environ(env: SCons.Environment, user_settings, f: collections.abc.Callable[[str], None], msgprefix: str, append_newline='\n'):
		f(f'{msgprefix}: CHOST: {(user_settings.CHOST)!r}{append_newline}')
		for v in (
			'CXX',
			'CPPDEFINES',
			'CPPPATH',
			'CPPFLAGS',
			'CXXFLAGS',
			'LIBS',
			'LINKFLAGS',
		) + (
			(
				'RC',
				'RCFLAGS',
			) if user_settings.host_platform == 'win32' else (
				'FRAMEWORKPATH',
				'FRAMEWORKS',
			) if user_settings.host_platform == 'darwin' else (
			)
		):
			f(f'{msgprefix}: {v}: {(env.get(v, None))!r}{append_newline}')
		penv = env['ENV']
		for v in (
			'CCACHE_PREFIX',
			'DISTCC_HOSTS',
		):
			f(f'{msgprefix}: ${v}: {(penv.get(v, None))!r}{append_newline}')

class Git(StaticSubprocess):
	@dataclass(eq=False)
	class ComputedExtraVersion:
		describe: str
		status: str
		diffstat_HEAD: str
		revparse_HEAD: str
		__slots__ = ('describe', 'status', 'diffstat_HEAD', 'revparse_HEAD')
	UnknownExtraVersion = (
		# If the string is alphanumeric, then `git archive` has rewritten the
		# string to be a commit ID.  Use that commit ID as a guessed default
		# when Git is not available to resolve a current commit ID.
		ComputedExtraVersion('', None, None, 'archive_7a84b3f307ac6f72fd440e55b149d7c2c942dfaf') if '7a84b3f307ac6f72fd440e55b149d7c2c942dfaf'.isalnum() else
		# Otherwise, assume that this is a checked-in copy.
		ComputedExtraVersion(None, None, None, None)
		)
	# None until computed, then ComputedExtraVersion once cached.
	__computed_extra_version: typing.ClassVar[None | ComputedExtraVersion] = None
	__path_git: typing.ClassVar[None | list[str]] = None
	# `__pcall_missing_git`, `__pcall_found_git`, and `pcall` must have
	# compatible signatures.  In any given run, there will be at most
	# one call to `pcall`, which then patches itself out of the call
	# chain.  A run will call either __pcall_missing_git or
	# __pcall_found_git (depending on whether $GIT is blank), but never
	# both in the same run.
	@classmethod
	def __pcall_missing_git(cls, args: list[str], stderr=None, _missing_git=StaticSubprocess.CachedCall(None, None, 1)):
		return _missing_git
	@classmethod
	def __pcall_found_git(cls, args: list[str], stderr=None, _pcall=StaticSubprocess.pcall):
		return _pcall(cls.__path_git + args, stderr=stderr)
	@classmethod
	def pcall(cls, args: list[str], stderr=None):
		git = cls.__path_git
		if git is None:
			cls.__path_git = git = cls.shlex_split(os.environ.get('GIT', 'git'))
		cls.pcall = f = cls.__pcall_found_git if git else cls.__pcall_missing_git
		return f(args, stderr)
	def spcall(cls, args: list[str], stderr=None):
		g = cls.pcall(args, stderr)
		if g.returncode:
			return None
		return g.out
	@classmethod
	def compute_extra_version(cls, _spcall=spcall) -> ComputedExtraVersion:
		c = cls.__computed_extra_version
		if c is None:
			v = cls.__compute_extra_version()
			cls.__computed_extra_version = c = cls.ComputedExtraVersion(
				v,
				_spcall(cls, ['status', '--short', '--branch']).decode(),
				_spcall(cls, ['diff', '--stat', 'HEAD']).decode(),
				_spcall(cls, ['rev-parse', 'HEAD']).rstrip().decode(),
			) if v is not None else cls.UnknownExtraVersion
		return c
	# Run `git describe --tags --abbrev=12`.
	# On failure, return None.
	# On success, return a string containing:
	#	first line of output of describe
	#	'*' if there are unstaged changes else ''
	#	'+' if there are staged changes else ''
	@classmethod
	def __compute_extra_version(cls) -> None | str:
		try:
			g = cls.pcall(['describe', '--tags', '--abbrev=12'], stderr=subprocess.PIPE)
		except OSError as e:
			if e.errno == errno.ENOENT:
				return None
			raise
		if g.returncode:
			return None
		_pcall = cls.pcall
		return (g.out.splitlines()[0] +	\
			(b'*' if _pcall(['diff', '--quiet']).returncode else b'') +	\
			(b'+' if _pcall(['diff', '--quiet', '--cached']).returncode else b'')
		).decode()

class ConfigureTests:
	@dataclass(eq=False)
	class _Collector:
		record: collections.abc.Callable[['ConfigureTest'], None]

		@dataclass(eq=False, slots=True)
		class RecordedTest:
			name: str
			desc: str
			# predicate is a sequence of zero-or-more functions that take a
			# UserSettings object as the only argument.  A recorded test is
			# only passed to the SConf logic if at most zero predicates return
			# a false-like value.
			#
			# Callers use this to exclude from execution tests which make no
			# sense in the current environment, such as a Windows-specific test
			# when building for a Linux target.
			predicate: tuple[collections.abc.Callable[['UserSettings'], bool]] = ()

		def __call__(self, f: collections.abc.Callable) -> collections.abc.Callable:
			desc = None
			doc = getattr(f, '__doc__', None)
			if doc is not None:
				doc = doc.rstrip().splitlines()
				if doc and doc[-1].startswith("help:"):
					desc = doc[-1][5:]
			self.record(self.RecordedTest(f.__name__, desc))
			return f

	class Collector(_Collector):
		tests: collections.abc.MutableSequence[collections.abc.Callable[['ConfigureTest'], None]]
		def __init__(self):
			# An unguarded collector maintains a list of tests, and adds
			# to the list as the decorator is called on individual
			# functions.
			self.tests = tests = []
			super().__init__(tests.append)

	class GuardedCollector(_Collector):
		__guard: tuple[collections.abc.Callable[['UserSettings'], bool]]
		def __init__(self, collector, guard: collections.abc.Callable[['UserSettings'], bool]):
			# A guarded collector delegates to the list maintained by
			# the input collector, instead of keeping a list of its own.
			super().__init__(collector.record)
			# `guard` is a single function, but the predicate handling
			# expects a sequence of functions, so store a single-element
			# tuple.
			self.__guard = guard,
			self.__RecordedTest = collector.RecordedTest
		def RecordedTest(self, name: str, desc: str, predicate=()):
			# Record a test with both the guard of this GuardedCollector
			# and any guards from the input collector objects, which may
			# in turn be instances of GuardedCollector with predicates
			# of their own.
			return self.__RecordedTest(name, desc, self.__guard + predicate)

	class CxxRequiredFeature:
		__slots__ = ('main', 'name', 'text')
		name: str
		text: str
		main: str
		def __init__(self, name: str, text: str, main: str = ''):
			self.name = name
			# Avoid generating consecutive underscores if the input
			# string has multiple adjacent unacceptable characters.
			# Pass alphanumeric characters through as-is.  Escape
			# non-alphanumeric by converting them to the hexadecimal
			# representation of their ordinal value.
			name = {'N' : f'test_{"".join(c if c.isalnum() else f"_{(ord(c)):x}" for c in name)}'}
			self.text = text % name
			self.main = f'{{{(main % name)}}}\n' if main else ''
	class Cxx11RequiredFeature(CxxRequiredFeature):
		std: int = 11
	class Cxx14RequiredFeature(CxxRequiredFeature):
		std: int = 14
	class Cxx17RequiredFeature(CxxRequiredFeature):
		std: int = 17
	class Cxx20RequiredFeature(CxxRequiredFeature):
		std: int = 20
	class CxxRequiredFeatures:
		__slots__ = ('features', 'main', 'text')
		features: list['CxxRequiredFeature']
		main: str
		text: str
		def __init__(self, features: list['CxxRequiredFeature']):
			self.features = features
			s = '/* C++{} {} */\n{}'.format
			self.main = '\n'.join((s(f.std, f.name, f.main) for f in features if f.main))
			self.text = '\n'.join((s(f.std, f.name, f.text) for f in features if f.text))
	class PCHAction:
		def __init__(self,context):
			self._context = context
		def __call__(self,text,ext):

=== debian/changelog ===
d1x-rebirth (0.60~git20250524-1) unstable; urgency=low

  * New GIT snapshot.
     - fix build with recent GCC/G++ (Closes: #1057551)
     - look for data in /usr/share/games/descent1 (Closes: #781584)
  * Build against SDL2 (Closes: #1038183)
  * d/control:
     + d1x-rebirth: add Depends on descent1-data | descent1-demo-data |
                                   game-data-packager (Closes: #776491)
     + set S-V to 4.7.2.
  * Install svg icons instead of old blurry xpm files.
  * Install AppStream metainfo.

 -- Sébastien Noel <sebastien@twolife.be>  Mon, 25 Aug 2025 09:39:10 +0200

d1x-rebirth (0.58.1-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Avoid defining objects twice; this allows building with GCC 10.
    Closes: #966187.

 -- Stephen Kitt <skitt@debian.org>  Sun, 02 Aug 2020 11:16:13 +0200

d1x-rebirth (0.58.1-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Allow building with Python 3. Closes: #947558.

 -- Stephen Kitt <skitt@debian.org>  Sat, 01 Feb 2020 16:24:25 +0100

=== debian/control ===
Source: d1x-rebirth
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Standards-Version: 4.7.2
Build-Depends: debhelper-compat (= 13),
               libglu1-mesa-dev,
               libphysfs-dev,
               libpng-dev,
               libsdl2-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               scons
XS-Autobuild: yes
Homepage: http://www.dxx-rebirth.com
Vcs-Browser: https://salsa.debian.org/twolife/dxx-rebirth
Vcs-Git: https://salsa.debian.org/twolife/dxx-rebirth.git

Package: d1x-rebirth
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, descent1-data | descent1-demo-data | game-data-packager
Recommends: timidity, freepats
Description: port of the 1995 classic game Descent 1: First Strike
 DXX-Rebirth is a Source Port of the Descent & Descent ][ Engines and
 provides classical Gameplay combined with OpenGL graphics and effects,
 a bunch of improvements and new features.
 .
 This package provides the engine to play "Descent 1: First Strike"
 .
 Original game data is needed to play this game.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))

%:
	dh $@

override_dh_clean:
	scons --clean
	dh_clean .sconsign.dblite build/

override_dh_auto_build:
	CFLAGS="$(CFLAGS) $(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
        scons prefix=/usr verbosebuild=1 ipv6=1 sdl2=1 --debug=presub -j $(NUMJOBS)

override_dh_auto_install:
	dh_auto_install --destdir=tmp

execute_before_dh_install:
	install -m644 contrib/packaging/linux/descent.svg  build/d1x-rebirth.svg
	install -m644 d1x-rebirth/d1x-rebirth.desktop build/io.github.dxx_rebirth.dxx_rebirth.d1x-rebirth.desktop

override_dh_installchangelogs:
	dh_installchangelogs -pd1x-rebirth d1x-rebirth/RELEASE-NOTES.txt

=== debian/watch ===
Version: 5
Mode: git
Pgpmode: none
Source: https://github.com/dxx-rebirth/dxx-rebirth.git
Matching-Pattern: HEAD
Git-Pretty: 0.60~git%cd
Repack: yes
Compression: xz
